GET Staged Transaction

GET /payout/v1/stagedtransactions

Development Guide:

The 'Retrieve Staged Transaction' endpoint will look up a transaction by referenceNumber and will provide additional information about a Payout. In some jurisdictions, regulation stipulates "additional transactional information" is to be provided at the time of Payout. This endpoint securely provides the additional information for regulatory purposes.



1. Prepare headers, authentication & parameters:

The application must call the 'Retrieve a transaction' endpoint with a GET HTTP method, providing the OAuth access_token and all other required headers. The application must pass the transaction referenceNumber as a path parameter to retrieve the transaction.


Note: MoneyGram uses the OAuth 2.0 framework. The application must use their OAuth client credentials to generate an access_token by calling the Get Access Token endpoint. The token is valid for 1 hour and must be passed as a header value in all subsequent API HTTP calls. Learn More


🚀

Launch Example Code




2. Make a request and handle the response:

The application must call 'Retrieve Staged transaction' endpoint with a GET HTTP method. The application must build to handle the following response scenarios:


  • Success | Parse the Response | 200 OK HTTP Status | "availableForPayout": true When the 'Retrieve a transaction' by referenceNumber endpoint responds with a 200 HTTP Status the response will typically return the transactionId, payoutId, sender, receiver and transactionInformation fields. There will be additional data about the sender provided, depending on market regulation.

  • Failed | Handle the Error | 400 Bad Request HTTP Status When the 'Retrieve a Transaction' endpoint responds with 400 HTTP Status, specific error code/s will be returned with an array of offending fields. The application will need to resolve these errors and resubmit the request.

Note: Access to the API is secured by business rules and will only be returned to eligible partners. To understand how you access this API, please refer to your MoneyGram technical consultant.


🚀

Launch Example Code

.




4. You're Done! Proceed to Update a Transaction API:

The application must execute the 'Update a staged transaction' endpoint to get the readyForCommit": true.





Business Rules to Code


🔎
  • Ready for Payout & Available status: The transaction can only be paid out if the transaction is in an AVAILABLE status and the "availableForPayout": true is returned in the response.
  • Send & Payout at the same store: A Payout cannot be received at the same store location where the transaction was sent (i.e. The application cannot Payout a transaction using the same partnerAgentId that was used to send the transfer).


Code Examples


const axios = require('axios');
const { v4: uuidv4 } = require('uuid');

const additionalInformation = async () => {

    // Step 1: Read configuration values with upmost security
    const token = "your_access_token_from_oauth_response"
    // For production - api.moneygram.com & For test - sandboxapi.moneygram.com
    const transactionId = "current_transaction_id";
    const host = "sandboxapi.moneygram.com";
    const url = 'https://' + host + '/payout/v1/stagedtransactions/' + referenceNumber + '/additionalInformation';

    // Step 2: Create the GET request headers & params

    const headers = {
        'Content-Type': 'application/json',
        'X-MG-ClientRequestId': uuidv4(), // New UUID for each request tracing
        'Authorization': 'Bearer ' + token,
    };

    const params = {
        agentPartnerId: "your_partner_id",
        targetAudience: "AGENT_FACING",
        userLanguage: "en-US",
    }

    try {
        // Step 3: Send the request and obtain the response
        axios.get(url, { params, headers })
            .then(function (response) {
                // Step 4: Parse the success response and process further
                // Verify readyForCommit is true, if yes, transaction is ready to commit
                console.log(JSON.stringify(response.data, null, 2))
            })
            .catch(function (error) {
                // Step 5: Parse the error response and handle the errors
                if (error.response) {
                    console.log('Response status:', error.response.status);
                    console.log('Response body:', error.response.data);
                } else {
                    // TODO: handle generic errors
                    console.error('Error:', error.message);
                }
            });
    } catch (error) {
        // TODO: handle exception
        console.error('Error:', error.message);
    }
};

additionalInformation();
import requests
import uuid
import json

def additional_information():
    # Step 1: Read configuration values with upmost security
    token = "your_access_token_from_oauth_response"
    # For production - api.moneygram.com & For test - sandboxapi.moneygram.com
    transactionId = "current_transaction_id";
    host = "sandboxapi.moneygram.com";
    url = 'https://' + host + '/payout/v1/stagedtransactions/'+ referenceNumber + '/additionalInformation';

    # Step 2: Create the GET request headers & params

    headers = {
        'Content-Type': 'application/json',
        'X-MG-ClientRequestId': str(uuid.uuid4()), # New UUID for each request tracing
        'Authorization': 'Bearer ' + token,
    }

    params = {
        'agentPartnerId': 'your_partner_id',
        'targetAudience': 'AGENT_FACING',
        'userLanguage': 'en-US',
    }

    try:
        # Step 3: Send the request and obtain the response
        response = requests.get(url, params=params, headers=headers)

        # Step 4: Parse the success response and process further
        if response.status_code == 200:
            parsed_response = json.dumps(json.loads(response.text), indent=2)
            print(parsed_response)
        else:
            # Step 5: Parse the error response and handle the errors
            print("Request failed with status code:", response.status_code)
            print(json.dumps(json.loads(response.text), indent=2))

    except requests.exceptions.RequestException as e:
        # Print any error that occurred during the request
        # TODO: handle exception
        print("An error occurred:", e)

additional_information()
package payout;

import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.UUID;

public class AdditionalInformation {

    public static void main(String[] args) {
        // Step 1: Read configuration values with upmost security
        String token = "your_access_token_from_oauth_response";

        // For production - api.moneygram.com & For test - sandboxapi.moneygram.com
        String host = "sandboxapi.moneygram.com";

        // Step 2: Create the GET request headers & params
        // Mandatory Query params
        String agentPartnerId = "your_partner_id";
        String userLanguage = "en-US";

        // Optional Query params
        String targetAudience = "AGENT_FACING";

        // Mandatory Path params
        String transactionId = "current_transaction_id";

        String uri = "https://" + host + "/payout/v1/stagedtransactions/" + referenceNumber + "/additionalInformation"
                + "agentPartnerId=" + agentPartnerId
                + "&userLanguage=" + userLanguage
                + (targetAudience.isBlank() ? "" : "&targetAudience=" + targetAudience);

        HttpClient httpClient = HttpClient.newHttpClient();
        HttpRequest request = HttpRequest.newBuilder()
                .uri(URI.create(uri))
                .GET()
                .setHeader("Authorization", "Bearer " + token)
                .setHeader("X-MG-ClientRequestId", String.valueOf(UUID.randomUUID()))
                .build();

        try {
            // Step 3: Send the request and obtain the response
            HttpResponse<String> response = httpClient.send(request, HttpResponse.BodyHandlers.ofString());

            // Retrieve the status code and body from the response
            int statusCode = response.statusCode();

            // Step 4: Parse the success response and process further
            if (statusCode == 200) {
                String responseBody = response.body();
                System.out.println(responseBody);
            } else {
                // Step 5: Parse the error response and handle the errors
                String responseBody = response.body();
                System.out.println(responseBody);
            }
        } catch (Exception e) {
            e.printStackTrace();
            // TODO: handle exception
        }

    }
}




API structure


Header parameters

FieldTypeRequired/ OptionalDescription
X-MG-ClientRequestIdStringOptionalClient request ID that can be passed by the client application. Client request ID must be unique within a single session for unique requests. This attribute can be used for ensuring idempotent request processing for some APIs. MoneyGram recommends using a UUID for the value of this field.
X-MG-ConsumerIPAddressStringOptionalIP address of the system initiating the session.



Query parameters

Field

Type

Required/ Optional

Description

targetAudience

String

Required

Tailors MoneyGram’s error messages and field metadata to an in-store, digital, or crypto customer. (Enumerated value)
Note: For a full list of accepted target audience values, see the TARGET_AUDIENCE enumeration from the Reference Data Enumerations endpoint.

userLanguage

String

Required

Language used by the user/operator.

agentPartnerId

String

Required

Unique agent or partner identifier.

posId

String

Optional

Point of sale identifier of the client performing the API call.

operatorId

String Max length: 80

Required

Operator name or ID of the user performing the transaction. The name or ID must be populated from the agent or partner system and cannot be edited by the user.




Path parameters

FieldTypeRequired/ OptionalDescription
referenceNumberStringRequiredMoneyGram's reference number for the transaction



Response fields

Field

Type

Required/ Optional

Description

transactionId

String
Max length: 36

Optional

Unique identifier for the transaction resource

payoutId

String

Optional

Unique identifier for the transaction session

availableForPayout

Boolean

Optional

Identifies if the transaction is in a status available for payout

transactionStatus

String

Optional

MoneyGram's transaction status

transactionSubStatus.substatus

String

Optional

MoneyGram's transaction sub-status

transactionSubStatus.targetCustomer

String

Optional

Customer associated with a sub-status code

transactionSubStatus.customerAction

String

Optional

Message associated with the sub-status code

transactionSubStatus.dataToCollect.code

String

Optional

Unique code to identify the data or document to collect.

transactionSubStatus.dataCollect.dataCollection

String

Optional

Data or document needed to be collected from customer.

originatingCountryCode

String
Max Length: 3

Optional

3 digit ISO destination country code

destinationCountryCode

String
Max Length: 3

Optional

Transaction destination country (ISO alpha-3 code)
Note: For a full list of accepted destinationCountryCode ISO codes see Reference data API module and the subdivision endpoint: https://moneygram-group.readme.io/moneygram-developer/docs/countries-iso3-code

serviceOptionCode

String
Max length: 21

Required

Unique category code to identify the transaction method
For a full list of accepted serviceOptionCodes per destinationCountry see Reference data API module and the service options endpoint: https://moneygram-group.readme.io/moneygram-developer/docs/payout-options

serviceOptionName

String
Max length: 50

Optional

Unique name to identify the transaction method
Note: For a full list of accepted serviceOptionName per destinationCountry see Reference data API module and the service options endpoint: https://moneygram-group.readme.io/moneygram-developer/docs/service-options

sendAmount.amount.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Required

Transaction amount and currency excluding fees and exchange rate. Transaction currency (ISO alpha-3 code): https://moneygram-group.readme.io/moneygram-developer/docs/currencies
Note: For Crypto partners this is the fiat currency for the buy/sell or ramp on/ramp off

sendAmount.amount.currencyCode

String

Required

The sendAmount.amount.value currency code (ISO alpha-3 code)

sendAmount.fees.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Required

Fee amount and fee currency applied to transaction (Fee currency uses ISO alpha-3 code)

sendAmount.fees.currencyCode

String

Required

The sendAmount.fees.value currency code (ISO alpha-3 code)

sendAmount.taxes.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Optional

Tax amount and tax currency applied to the transaction by the the origin country (Tax currency uses ISO alpha-3 code)

sendAmount.taxes.currencyCode

String

Optional

The sendAmount.taxes.value currency code (ISO alpha-3 code)

sendAmount.discountsApplied.totalDiscount

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Optional

Transaction discount amount applied and currency type excluding fees and exchange rate. Transaction currency (ISO alpha-3 code)

sendAmount.discountsApplied.promotionDetails

String
Max length: 50

Optional

Additional details about the applied promotion to the transaction

sendAmount.total.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Required

Transaction total amount and transaction total currency including fees, taxes and discount. (Transaction total amount uses ISO alpha-3 code)

sendAmount.total.currencyCode

String

Required

The sendAmount.total.value currency code (ISO alpha-3 code)

receiveAmount.amount.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Required

Transaction received amount and transaction receive currency (Transaction total amount uses ISO alpha-3 code)

receiveAmount.amount.currencyCode

String

Required

The receiveAmount.amount.value currency code (ISO alpha-3 code)

receiveAmount.fees.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Optional

Received fee and receive currency applied to the transaction by the destination country (Transaction total amount uses ISO alpha-3 code)

receiveAmount.fees.currencyCode

String

Optional

The receiveAmount.fees.value currency code (ISO alpha-3 code)

receiveAmount.taxes.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Optional

Tax amount and tax currency applied to the transaction by the the origin country (Tax currency uses ISO alpha-3 code)

receiveAmount.taxes.currencyCode

String

Optional

The receiveAmount.taxes.value currency code (ISO alpha-3 code)

receiveAmount.total.value

Number
Min length: 0
Max length: 14
Max Decimal Value: 3

Required

Receive amount total and receive transaction currency to be picked up/deposited in destination country including fees, taxes and discount. (Transaction total amount uses ISO alpha-3 code)

receiveAmount.total.currencyCode

String

Required

The receiveAmount.total.value currency code (ISO alpha-3 code)

receiveAmount.fxRate

Number
Max Decimal Value: 6

Required

FX rate applied to transaction

receiveAmount.fxRateEstimated

Boolean

Optional

Indicates whether the FX is “estimated” and amount, taxes and total cannot be guaranteed. The word “estimated” must appear before receiveAmount.amount, receiveAmount.taxes and receiveAmount.total only when true.

originalReceiveAmount.amount.value

Number

Required

The transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field

originalReceiveAmount.amount.currencyCode

String

Required

Value's Currency code (ISO alpha-3 code

originalReceiveAmount.fees.value

Number

Optional

The transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field

originalReceiveAmount.fees.currencyCode

String

Optional

Value's Currency code (ISO alpha-3 code

originalReceiveAmount.taxes.value

Number

Optional

The transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field

originalReceiveAmount.taxes.currencyCode

String

Optional

Value's Currency code (ISO alpha-3 code

originalReceiveAmount.total.value

Number

Required

The transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field

originalReceiveAmount.total.currencyCode

String

Required

Value's Currency code (ISO alpha-3 code

originalReceiveAmount.fxRate

Number
Max Decimal Value: 6

Required

Fx Rate applied to transaction

originalReceiveAmount.fxRateEstimated

Boolean

Optional

Indicates whether the FX is “estimated” and amount, taxes and total cannot be guaranteed. The word “estimated” must appear before receiveAmount.amount, receiveAmount.taxes and receiveAmount.total only when true.

estimatedReceiveAmountInLocalCurrency.total.value

Number

Required

Transaction received amount and transaction receive currency (Transaction total amount uses ISO alpha-3 code)

estimatedReceiveAmountInLocalCurrency.total.currencyCode

String

Required

The estimatedReceiveAmountInLocalCurrency.amount.value currency code (ISO alpha-3 code)

estimatedReceiveAmountInLocalCurrency.fxRate

Number

Required

FX Rate Charged

estimatedReceiveAmountInLocalCurrency.fxRateEstimated

Boolean

Optional

Indicates whether the all attributes related to Fx are estimated

sender.name.firstName

String
Min length: 1
Max length: 20

Required

First name

sender.name.middleName

String
Min length: 1
Max length: 20

Optional

Middle name (if applicable)

sender.name.lastName

String
Min length: 1
Max length: 30

Required

Last name

sender.name.secondLastName

String
Min length: 1
Max length: 30

Optional

Second last name

receiver.name.firstName

String
Min length: 1
Max length: 20

Required

First name

receiver.name.middleName

String
Min length: 1
Max length: 20

Optional

Middle Name

receiver.name.lastName

String
Min length: 1
Max length: 30

Required

Last name

receiver.name.secondLastName

String
Min length: 1
Max length: 30

Optional

Second last name

receiver.address.line1

String Min length: 5 Max length: 30

Required

Residence address line 1

receiver.address.line2

String Min length: 0 Max length: 80

Optional

Residence address line 2
(if applicable)

receiver.address.line3

String Min length: 0 Max length: 80

Optional

Residence address line 3
(if applicable)

receiver.address.city

String Min length: 1 Max length: 20

Required

City of Residence

receiver.address.countrySubdivisionCode

String Length: 6

Optional

State/province of residence

receiver.address.countryCode

String Length: 3

Required

Country of residence
(ISO Alpha-3 Code)

receiver.address.postalCode

String Min length: 2 Max length: 10

Optional

Postal code/ZIP code of residence

receiver.mobilePhone.number

String Min length: 5 Max length: 14

Optional

Phoen Number

receiver.mobilePhone.countryDialCode

String Min length: 1 Max length: 3

Optional

Country calling code
(ISO alpha-3 code)

receiver.email

String Min length: 1 Max length: 255

Optional

Email address

receiver.personalDetails.genderCode

String

Optional

Gender (Enumerated value)

receiver.personalDetails.dateOfBirth

String Length: 10

Required

Date of birth (YYYY-MM-DD)

receiver.personalDetails.birthCity

String Min length: 0 Max length: 20

Optional

City of birth

receiver.personalDetails.birthCountryCode

String Max Length: 3

Required

Country of birth (ISO alpha-3 code) _NOTE: For a full list of accepted birth.CountryCodes see ‘Reference data API module’ and the countryInfo endpoint: _

receiver.personalDetails.citizenshipCountryCode

String Max Length: 3

Optional

Citizenship Code (ISO alpha-3 code)

receiver.personalDetails.occupationCode

String

Optional

Occupation/Employment (Enumerated value) _NOTE: For a full list of accepted Occupation Codes. See the OCCUPATION enumeration from the Reference Data Enumerations endpoint _

receiver.personalDetails.politicalExposedPerson

Boolen

Optional

Flag to declare a Politically Exposed Person (PEP)

receiver.personalDetails.nationalityCountryCode

String Min Length: 3 Max Length: 3

Optional

Country of citizenship (ISO alpha-3 code)

receiver.primaryIdentification.typeCode

String

Optional

example: SSN for Social Security Number identification document. Type of identification document (Enumerated Value)

receiver.primaryIdentification.id

String Max length: 30

Required

Identification document number

receiver.primaryIdentification.issueCountrySubdivisionCode

String Max length: 6

Optional

Issuing state/province of identification document

receiver.primaryIdentification.issueCountryCode

String Max Length: 3

Required

Issuing country of identification document

receiver.primaryIdentification.expirationYear

String Length: 4 Format: YYYY

Optional

Expiration year of identification document (YYYY)

receiver.primaryIdentification.expirationMonth

String Length: 4 Format: MM

Optional

Expiration month of identification document (MM)

receiver.primaryIdentification.expirationDay

String Length: 4 Format: DD

Optional

Expiration month of identification document (DD)

receiver.primaryIdentification.issueAuthority

String Min length: 0 Max length: 30

Optional

Issuing authority of identification document

receiver.primaryIdentification.issueCity

String Min length: 0 Max length: 20

Optional

Issuing city of identification document

receiver.primaryIdentification.issueYear

String Length: 4 Format: YYYY

Optional

Expiration year of identification document (YYYY)

receiver.primaryIdentification.issueMonth

String Length: 4 Format: MM

Optional

Expiration month of identification document (MM)

receiver.primaryIdentification.issueDay

String Length: 4 Format: DD

Optional

Expiration month of identification document (DD)

receiver.secondaryIdentification.typeCode

String

Optional

example: SSN for Social Security Number identification document Type of identification document (Enumerated Value)

receiver.secondaryIdentification.id

String Max length: 30

Optional

Identification document number

receiver.secondaryIdentification.issueCountrySubdivisionCode

String Max length: 6

Optional

Issuing state/province of identification document

receiver.secondaryIdentification.issueCountryCode

String Max length: 3

Optional

Issuing country of identification document

receiver.secondaryIdentification.expirationYear

String Length: 4 Format: YYYY

Optional

Expiration year of identification document (YYYY)

receiver.secondaryIdentification.expirationMonth

String Length: 4 Format: MM

Optional

Expiration month of identification document (MM)

receiver.secondaryIdentification.expirationDay

String Length: 4 Format: DD

Optional

Expiration month of identification document (DD)

receiver.secondaryIdentification.issueAuthority

String Min length: 0 Max length: 30

Optional

Issuing authority of identification document

receiver.secondaryIdentification.issueCity

String Min length: 0 Max length: 20

Optional

Issuing city of identification document

receiver.secondaryIdentification.issueYear

String Length: 4 Format: YYYY

Optional

Expiration year of identification document (YYYY)

receiver.secondaryIdentification.issueMonth

String Length: 4 Format: MM

Optional

Expiration month of identification document (MM)

receiver.secondaryIdentification.issueDay

String Length: 4 Format: DD

Optional

Expiration month of identification document (DD)

additionalDetails

Dynamic

Optional

Dynamic field key/values